critical.valuesWSP <-
function(ts,s0,noctave,nvoice,w0,sw,siglevel=0.95,nreal=1000)
	{
	t=time(ts)
	dt=t[2]-t[1]
	cat("# calculating critical values by means of MC-simulations \n")
	#s0unit=s0*frequency(ts)*(w0+sqrt(2+w0*w0))/(4*pi)	
	s0unit=s0/dt*w0/(2*pi)                  #(CORRECT) 
	s0log=as.integer((log2(s0unit)-1)*nvoice+1.5)	
	wsp0 <- rawWSP(ts,s0,noctave,nvoice,w0,sw)
	S <- dim(wsp0)[2]
	n <- 1 + 2*as.integer( sqrt(2) * 2^((S-sw+s0log-1)/nvoice+1) )
	center <- (n-1)/2+1
	cv <- matrix(rep(0,S*length(siglevel)),ncol=S)
	rmatrix <- matrix(0,nrow=nreal,ncol=S)
	# Fitting AR1-process (red noise) to data
	arts0 <- ar(ts,order.max=1)
	sdts0 <- sd(ts[1:length(ts)]) 
	tsMC <- ts(data=rep(0,n),start=t[1],frequency=1/dt)
	# MC Simulations
	for (i in 1:nreal)
		{
		tsMC[1:n] <- arima.sim(list(ar = arts0$ar), n, sd = 1)
		tsMC <- tsMC/sd(tsMC[1:n])*sdts0
		rmatrix[i,] <- rawWSP(tsMC,s0,noctave,nvoice,w0,sw)[center,]
		cat("#",i,", ")
    		}
	for (s in (1+sw):(S-sw)) { rmatrix[,s] <- sort(rmatrix[,s]) }
	for (i in 1:length(siglevel))
		{ 
		sigindex <- as.integer(nreal*siglevel[i])
		cvv <- rmatrix[sigindex,]
		cvv[is.na(cvv)] <- 0
		cv[i,] <- cvv
  		}
 	}
