pftscores <-
function(ass,tax2pft,taxcar,pftassign,pft2biom,transf=0,outfile=NULL)
{
        
# initialisation

n<-nrow(ass)
m<-ncol(ass)
ntax<-nrow(tax2pft)
mpft<-ncol(tax2pft)
mbiom=ncol(pft2biom)
pftassign[pftassign==0]<-mpft+1
if (!is.null(outfile)) {
	fgraph=paste(outfile,".pdf",sep="")
	ftext=paste(outfile,".txt",sep="")
	sink(file=ftext)
	pdf(file=fgraph)
}


PFT<-list(title="pft scores of the assemblage matrix")
PFT$scores<-matrix(0,n,mpft+1)
PFT$taxpos<-rep(0,n)
PFT$taxneg<-rep(0,n)
scores=matrix(0,n,mpft)

# correspondance between ass and tax2pft

x=matrix(0,n,ntax)
for (j in 1:ntax) {
        ii<-match(rownames(tax2pft)[j],colnames(ass),nomatch=NA)
        if (!is.na(ii)) {
                x[,j]<-ass[,ii]
        }
 }

# Summing according to taxcar

y=x
if (transf==1) {y=sqrt(y)}
if (transf==2) {y=log(y)}
PFT$taxpos=apply(y[,taxcar>0],1,sum)
PFT$taxneg=apply(y[,taxcar<0],1,sum)
dif=PFT$taxpos-PFT$taxneg
lim=max(abs(dif))/10
dif[abs(dif)<lim]<-0

# filtre tax2pft et calcul des scores

for (k in 1:ntax) {
	y=x[,k]
	if (transf==1) {y=sqrt(y)}
	if (transf==2) {y=log(y)}
	for (j in 1:mpft) {
		y[y<tax2pft[k,j]]<-0
		fac=tax2pft[k,j]
		if(fac>0) {fac=1}
		scores[,j]=scores[,j]+y*fac
		}
	}
# re-affectation of the pft according to the temperature character of the spectrum

ind=sign(dif)+2
kk=as.matrix(pftassign)
for (j in 1:mpft) {
	for (i in 1:n) {
		PFT$scores[i,kk[ind[i],j]]=PFT$scores[i,kk[ind[i],j]]+scores[i,j]
		}
	}

# calcul de biomes

PFT$scores=PFT$scores[,1:mpft]
PFT$biomsco=PFT$scores%*%as.matrix(pft2biom)
biome=rep(NA,mbiom)
cor=seq(1,1+0.000001*(mbiom-1),0.000001)
for (i in 1:n) {
	nub=which.max(PFT$biomsco[i,]*cor)
	biome[i]=colnames(pft2biom)[nub]
	}


# finalisation
colnames(PFT$scores)<-colnames(tax2pft)
rownames(PFT$scores)<-rownames(ass)
names(PFT$taxpos)<-rownames(ass)
names(PFT$taxneg)<-rownames(ass)
colnames(PFT$biomsco)<-colnames(pft2biom)
rownames(PFT$biomsco)<-rownames(ass)
PFT$biome=as.matrix(biome)
rownames(PFT$biome)<-rownames(ass)
colnames(PFT$biome)<-"biome"

if (!is.null(outfile))
	{
	sink(file=ftext,append=TRUE)
	cat("\nImpression de la liste RFcpb\n")
	print(IXargc)
	dev.off()
	sink()
	sink()
	sink()
	}

return(PFT)
}
