recMAT <-
function(ass,clim,fass,fclim=FALSE,ichd=0,kana=8,wghts=NULL,mcon=NULL,fcon=NULL,outfile=NULL)
{
# Initialisation

pasdeseuil=FALSE
if (kana<0) 
	{
	kana=abs(kana)
	pasdeseuil=TRUE
	}
na<-nrow(ass)
ma<-ncol(ass)
nc<-nrow(clim)
mc<-ncol(clim)
nfa<-nrow(fass)
mfa<-ncol(fass)
if (identical(na,nc)==FALSE) { stop ("both ass & clim matrices have not same number of rows")}
if (identical(mfa,ma)==FALSE) { stop ("both ass & fass matrices have not same number of columns")}
MAT<-list(title="Transfer function estimates by MAT method")
MAT$rmse<-rep(NA,mc)
MAT$r2<-rep(NA,mc)
MAT$rmsep<-rep(NA,mc)
MAT$r2p<-rep(NA,mc)
MAT$CE<-rep(NA,mc)
MAT$clim<-matrix(NA,nc,mc*3)
MAT$fclim<-matrix(NA,nfa,mc*3)
MAT$nbanal<-matrix(0,nfa)
MAT$mindist<-matrix(NA,nfa)
MAT$maxdist<-matrix(NA,nfa)
MAT$analist<-matrix(NA,nfa,kana)
MAT$anadist<-matrix(NA,nfa,kana)
MAT$ananames<-matrix(NA,nfa,kana)

option<-"extrapolation"
if (!is.null(fclim)) 
	{
	nfc<-nrow(fclim)
	mfc<-ncol(fclim)
	if (identical(nfc,nfa)==FALSE) {stop ("both fclim & fass matrices have not same number of rows")}
	option<-"verification"
	}
if (!is.null(outfile)) 
	{
	fgraph=paste(outfile,".pdf",sep="")
	ftext=paste(outfile,".txt",sep="")
	sink(file=ftext)
	pdf(file=fgraph)
	}
if (is.null(mcon)) {mcon=rep(NA,na)}
if (is.null(fcon)) {fcon=rep(NA,nfa)}
MAT$fcon=fcon
cat("TRANSFER FUNCTION : Modern analogues technique (MAT) \n")
cat("----------------------------------------------------------------------------------------\n")
mdist<-"euclidian"
if(ichd==3) { mdist="canberra" }
#Display input parameters in a file
cat("max number of analogues = ",kana,"\n")
cat("distance option (0=euclidian /1=chord /2=log /3=canberra) = ",ichd,"\n")
cat("Weights used for each taxon = \n",wghts,"\n")
# data characteristics
nfc<-0
mfc<-0
option="extrapolation"
if (length(fclim)>1)
	{
	nfc<-nrow(fclim)
	mfc<-ncol(fclim)
	if (identical(nfc,nfa)==FALSE) {stop ("both fclim & fass matrices have not same number of rows")}
	option="verification"
	}
# beginning of analogue search for the calibration data
bac <- bestanal (ass,ass,ichd,wghts=wghts,mcon=mcon,fcon=mcon)
seuil=bac$seuil
if (pasdeseuil==TRUE) {seuil=seuil*100} 
ye <- WA_reconstruction (clim,bac$dist,bac$list,kana,seuil)
bav <- bestanal (ass,fass,ichd,wghts=wghts,mcon=mcon,fcon=fcon) 
yp <- WA_reconstruction (clim,bav$dist,bav$list,kana,seuil)
for (i in 1:nfa) 
	{
        for (k in 1:kana) { MAT$ananames[i,k]<-rownames(ass)[yp$analist[i,k]] }
	}
MAT$analist=yp$analist
MAT$anadist=yp$analdist
cat("In the verification step, r2p (or reduction of error) compares the predictions to the calibration period climatology\n") 
cat("In the verification step, CE (or coefficient of efficiency) compares the predictions to the verification period climatology\n") 
#loop on the climatic variables
for (j in 1:mc) 
	{
	cat("\nDependent Variable : ",colnames(clim)[j],"\n")
	cat("----------------------------------------\n")
	jj<-(j-1)*3
	MAT$clim[,jj+1]<-ye$rmean[,j]
	MAT$clim[,jj+2]<-ye$rmean[,j]-ye$rmin[,j]
	MAT$clim[,jj+3]<-ye$rmax[,j]-ye$rmean[,j]
	MAT$fclim[,jj+1]<-yp$rmean[,j]
	MAT$fclim[,jj+2]<-yp$rmean[,j]-yp$rmin[,j]
	MAT$fclim[,jj+3]<-yp$rmax[,j]-yp$rmean[,j]
	if (j==1) 
		{
		MAT$nbanal<-yp$nbanal
		MAT$mindist<-yp$mindist
		MAT$maxdist<-yp$maxdist
		}
	MAT$rmse[j]<-mean((clim[,j]-ye$rmean[,j])^2,na.rm=TRUE)^0.5
	MAT$r2[j]<-1-(MAT$rmse[j]/sd(clim[,j],na.rm=TRUE))^2
	cat("R2 = ",MAT$r2[j],"  -- RMSE = ",MAT$rmse[j],"calculated on ",na,"  observations\n")
	smin<-min(clim[,j])
	smax<-max(clim[,j])
	plot(c(smin,smax),c(smin,smax), type='l',xlab=paste(colnames(clim)[j]," calib"), ylab="Predicted MAT", main="",col="green")
	points(clim[,j],MAT$clim[,(jj+1)],pch=19,col='blue')	
# verification
	if (option=="verification") 
		{
		MAT$rmsep[j]<-mean((fclim[,j]-yp$rmean[,j])^2,na.rm=TRUE)^0.5
		MAT$r2p[j]<-1-(MAT$rmsep[j]/sd(fclim[,j],na.rm=TRUE))^2
		MAT$CE[j]<-1-(MAT$rmsep[j]/sd(clim[,j],na.rm=TRUE))^2
		cat("R2p (RE) = ",MAT$r2p[j],"  -- CE = ",MAT$CE[j],"  -- RMSEp = ",MAT$rmsep[j],"calculated on ",nfa,"  observations\n")
		smin<-min(cbind(t(clim[,j]),t(fclim[,j])))
		smax<-max(cbind(t(clim[,j]),t(fclim[,j])))
		plot(c(smin,smax),c(smin,smax), type='l',xlab=paste(colnames(clim)[j]," calib (blue) / verif (red)"), ylab="Predicted MAT", main="",col="green")
		points(clim[,j],MAT$clim[,(j-1)*3+1],pch=19,col='blue')
		points(fclim[,j],MAT$fclim[,(j-1)*3+1],col='red',pch=21)
		}
	else
		{
# extrapolation
		cat("the estimated climate is put in the MAT$fclim matrix(reconstruction, lower bar, upper bar)\n")
		}
	}
coln<-rep(NA,mc*3)
for (j in 1:mc) {
	coln[(j-1)*3+1]<-colnames(clim)[j]
	coln[(j-1)*3+2]<-paste(colnames(clim)[j],'_i',sep="")
	coln[(j-1)*3+3]<-paste(colnames(clim)[j],'_s',sep="")
}
colnames(MAT$fclim)<-coln
colnames(MAT$clim)<-coln
rownames(MAT$fclim)<-rownames(fass)	
rownames(MAT$clim)<-rownames(clim)	
rownames(MAT$analist)<-rownames(fass)
rownames(MAT$anadist)<-rownames(fass)
rownames(MAT$ananames)<-rownames(fass)
names(MAT$rmse)<-colnames(clim)
names(MAT$r2)<-colnames(clim)
names(MAT$rmsep)<-colnames(clim)
names(MAT$r2p)<-colnames(clim)
names(MAT$CE)<-colnames(clim)
cat("\nList MAT\n")
cat("MAT$analist contains the list of the analogues for each extrapolation sample\n")
cat("MAT$anadist contains the list of the analogue distance for each extrapolation sample\n")
print(MAT)
if (!is.null(outfile)) 
	{
	dev.off()
	sink()
	sink()
	sink()
	print("end")
	}
return(MAT)
}
