wavecohsp <-
function(data,s0=2,noctave=6,nvoice=20,w0=6,sw=0,siglevel=0.95,nreal=100,phase=TRUE,logscale=FALSE,units="",outfile=NULL)
# uses bivar (D. Maraun)
{
# initialisation

	require(Rwave)
	devices="screen"
	if (!is.null(outfile)) 
		{
		fgraph=paste(outfile,sep="")
		ftext=paste(outfile,".txt",sep="")
		sink(file=ftext)
		devices="ps"
		}
	n<-nrow(data)
	m<-ncol(data)

	cat(paste("The number of octaves is ",noctave,"\n"))
	cat(paste("The number of voices is ",nvoice,"\n"))
	cat(paste("The filter size sw is ",sw,"\n"))

	t<-as.numeric(rownames(data))
	t0<-t[1]
	df<-(n-1)/(t[n]-t[1])
	if (s0<=2./df)
		{
		s0 <- 2./df
		cat(paste("# s0 set to ",s0," (Nyquist period =",2/df,")\n"))
		}
# output
cat("Coxpectral analysis by wavelets \n")
cat("-----------------------------------------------------------\n")
# main loop
	for (j in 1:(m-1)) 
		{
		for (k in (j+1):m) 
			{
			cat("Series ",j,k," : ",colnames(data)[j]," / ",colnames(data)[k]," \n")
			cat("----------------------------------------------------------\n")
			ts1<-ts(data[,j],start=t0,frequency=df)
			ts1anom <- ts1-mean(ts1)
			ts2<-ts(data[,k],start=t0,frequency=df)
			ts2anom <- ts2-mean(ts2)
			ts1.cwt <- cwt.ts(ts1anom,s0,noctave,nvoice,w0)
			ts2.cwt <- cwt.ts(ts2anom,s0,noctave,nvoice,w0)
			cosp <- Re(ts1.cwt)*Re(ts2.cwt) + Im(ts1.cwt)*Im(ts2.cwt)
			quad <- Im(ts1.cwt)*Re(ts2.cwt) - Re(ts1.cwt)*Im(ts2.cwt)
			wsp1 <- Mod(ts1.cwt)^2
			wsp2 <- Mod(ts2.cwt)^2
			smcosp <- smooth.matrix(cosp,sw)
			smquad <- smooth.matrix(quad,sw)
			smwsp1 <- smooth.matrix(wsp1,sw)
			smwsp2 <- smooth.matrix(wsp2,sw)
#			if (sqr==FALSE)
#    			wcoh <- sqrt((smcosp^2+smquad^2)/(smwsp1*smwsp2))
#			else
				wcoh <- (smcosp^2+smquad^2)/(smwsp1*smwsp2)
  
			if (phase) { phs <- atan2(smquad,smcosp) }
			else { phs <- 0 }
			if (siglevel[1]!=0) { critval <- critical.valuesWCO(s0,noctave,nvoice,w0,sw,siglevel) }
			else { critval <- 0 }
			wcoh[1,1] <- 0
			wcoh[1,1] <- 1
			phs[1,1] <- -pi
			phs[1,1] <- pi 
			fgraph1="samefile"
			if (j==1 && k==2) { fgraph1=fgraph }
			print(fgraph1)
			titre=paste("Wavelet Coherency: ",colnames(data)[j]," / ",colnames(data)[k])
			plot.wt(wcoh,phs,t,s0,noctave,w0,cv=0,markt=-999,marks=-999, logscale,phase,units,plottitle=titre,device=devices,file=fgraph1,split=FALSE,color=TRUE)
			WCS <- list(coherency=wcoh,phase=phs,times=t,scales=2^(0:(noctave*nvoice)/nvoice)*s0,critval=critval)
#			cat("Period ",WCS$scales,"\n")
# 			for (i in 1:n) 
#				{
#				cat("time ",t[i],"\n")
#				cat("cohs ",WCS$power[i,],"\n")
#				cat("crit ",WCS$critval,"\n")
#				}
#			cat("\n")
			}
		}

if (!is.null(outfile)) 
	{
	sink(file=ftext,append=TRUE)
#	cat("\nImpression de la liste WCS\n")
#	print(WCS)
	dev.off()
	sink()
	sink()
	sink()
	}
	return(WCS)
}
