\name{annts}
\alias{annts}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ transfer function using the bootstrap artificial neural networks }
\description{
  calculate a non-linear regression between dependent variables and regressors based on neural networks with possible time decays; all variables must be observed at constant time interval.
}
\usage{
  output=annts(data,varlag=c(1,0),k1,ntiter=100,outfile=NULL)
}
\arguments{
  \item{data}{ \code{data} is the matrix of the time-series dim(n,m) }
  \item{varlag}{ \code{varlag} is a (p,2) matrix where the first column indicates the numbers of the variables used for regressors and the second column the time delays (-1 means a lag of 1; +1 means an advance of 1) }
  \item{k1}{ \code{k1} is the number of neurones in the intermediate layer}
  \item{ntiter}{ \code{ntiter} is the number of iterations; default=100}
  \item{outfile}{ \code{outfile} is the filename for the log and graphics }
}
\details{
  The script uses "nnet" of library "nnet" for ANN fitting. The dependent variables are processed as a whole. The observation set is randomly divided into one calibration set (size 66% of n) and a verification set. The calibration subset is used to train the ANN which is applied afterwards to the verification subset. Statistics are calculated on both subsets. This function applies only on observations at constant time interval
}
\value{
output list ANN contains: 
  errc: the standardized errors (averaged on all the dependent variable) on the calibration data for each iteration;
  errv: the standardized errors (averaged on all the dependent variable) on the verification data for each iteration;
  r2c: squared r on calibration data for all dependent variables;
  r2v: squared r on verification data for all dependent variables;
  y the estimates of the depedent variables.
}
\references{ ~ ~ }
\author{ J. Guiot }
\note{ void
}
\examples{
  output=annts(globclim,varlag=cbind(c(1,2,3,3),c(0,0,0,-1)),k1=2)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ multivariate statistics}
\keyword{ artificial neural network}
\keyword{ time series}
\keyword{ autoregression}
