\name{denIXargc}
\alias{denIXargc}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Tree-ring series standardization using the adaptative regional growth curve (ARGC)}
\description{
  each tree-ring series is standardized using the adaptative regional growth curve, i.e. by non-linear regression on the ring age, the initial and maximum growth of the juvenil period. Master chronologies are calculated site by site
}
\usage{
output=denIXargc(dser,juvper=50,initper=10,missing=NA,gam=F,outfile=NULL)
}
\arguments{
  \item{dser}{ \code{dser} is the matrix of the tree-ring series, assumed to be tree averages (not cores) }
  \item{juvper}{ \code{juvper} is the duration (in years) of the juvenil period, see details for definition (default =50) }
  \item{initper}{ \code{initper} is the duration (in years) of the initial period, see details for definition (default =10) }
  \item{missing}{ \code{missing} is the code for missing values (default=NA) }
  \item{gam}{ \code{gam} is logical indicator for the fitting technique, T = gam, F = neural network (default=T) }
  \item{outfile}{ \code{outfile} is the filename for the log and graphics }
}
\details{
        The script uses "gam" of library "mgcv" to calculate trends by gam and "nnet" of library "nnet" to calculate trends by ANN. The function proceeds by tree. To determine the initial growth and the maximulm growth on the juvenil period, a loess smothing is applyied on each series: the initial growth is the mean smoothed growth on the initial period and the maximum growth is the maximum growth reached by the smoothed growth. The ARGC is calculated on all the series given in dser, three regressors are defined for each ring: its age (the number of rings from the beginning of the series), the initial growth of the series, the maximum growth of the juvenil period of the concerned series.
  Several populations can be put in the matrix dser; the last two characters of the series names define the  tree.
        The series are detrended by division of the raw series by the trend. After detrending, the cores are grouped per tree and tree means are provided as outputs. Afterwards, the trees of the same populations are grouped together. Graphics with raw series and indixed series are also given. 
}
\value{
  output IXargc list contains: 
  - treetrend, the trend of the tree series
  - treeindex, the indexed tree series 
  - popindex, the indexed populations (averages of the trees belonging to the same population
  - popsize, the number of cores belonging to the samle population; this value changes depending on time 
  - varpop, a two-column matrix of inter-tree and inter-year variances, for each tree (varpop has then a number of rows equal to the number of trees)  
}
\references{ ~ ~ }
\author{ J. Guiot }
\note{ void
}
\examples{
output=denIXargc(dentest.txt)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ neural networks}
\keyword{ trend} 
\keyword{ standardization} 
\keyword{ stationarization}
\keyword{ gam }

