\name{predLMb}
\alias{predLMb}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ prediction by bootstrap linear regression }
\description{
  calculate a linear multiple regression model between a matrix of predictand and a matrix of predictors; inference is done by bootstrap; regression coefficients are used for prediction; possibility to transform the predictors into principal components
}
\usage{
output=predLMb(xmat,ymat,xnewmat,ynewmat=FALSE,p=0,ncas=100,xstep=1,outfile=NULL)
}
\arguments{
  \item{xmat}{ \code{xmat} is the matrix of the potential predictors }
  \item{ymat}{ \code{ymat} is the matrix of the predictands }
  \item{xnewmat}{ \code{xnewmat} is the new matrix of predictors, for verification or extrapolation }
  \item{ynewmat}{ \code{ynewmat} is the new matrix of predictands, if verification is wanted }
  \item{p}{ \code{p} is the number of principal components to be used (if 0 = default, no PCA is done }
  \item{ncas}{ \code{ncas} is the number of bootstrap simulations wanted (100 = default) }
  \item{xstep}{ one observation each \code{xstep} is resampled in the bootstrap  (1 = default) }
  \item{outfile}{ \code{outfile} is the filename for the log and graphics }

}
\details{
        The script uses "lm" for the regression and "prcomp" for the principal components 
  It calculates a linear regression model between all the columns of "ymat" (separately) and the columns of "xmat".
  If the predictors are numerous and correlated, it is preferable to use the principal components. 
  The number of bootstrap simulation should be high enough to calculate good confidence intervals (at least 100). 
}
\value{
  output list contains: 
  rmse, r2, calculated on the calibration data; ymat the estimate (with 95% confidence intreval) of the predictands used for calibration;
  ynewmat the estimates of the new matrix of predictands; if there is verification, it contains also: rmsep, re and ce (calculated on the independent data). 
  re is the variance explained as compared with the calibration average and ce is the variance explained as compared with the verification average.
}
\references{ ~ ~ }
\author{ J. Guiot }
\note{ void
}
\examples{
output=predLMb(ss700po,ss700cl,fospo%,p=10)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ multiple regression}
\keyword{ bootstrap}
\keyword{ principal components }

