\name{recIK}
\alias{recIK}
\title{ transfer function using the Imbrie & Kipp method }
\description{
Calculate a linear multiple regression model between environmental variables and assemblages matrix; assemblages are transformed into PCs and introduced into the regression with degree 1 and 2; regression coefficients are used for prediction.
}
\usage{
output=recIK(xmat,ymat,xnewmat,ynewmat=FALSE,p=3,outfile=NULL)
}
\arguments{
  \item{xmat}{ \code{xmat} is the matrix of the predictors (assemblages) }
  \item{ymat}{ \code{ymat} is the matrix of the predictands (environment) }
  \item{xnewmat}{ \code{xnewmat} is the assemblages matrix  for verification or prediction }
  \item{ynewmat}{ \code{ynewmat} is the environmental matrix corresponding to xnewmat, if verification is wanted; if it is a prediction (reconstruction), assign to FALSE }
  \item{p}{ \code{p} is the number of principal components to be used (if not assign, it is assumed to be 3}
  \item{outfile}{ \code{outfile} is the filename for the log and graphics }
}
\details{
The script uses "lm" for the quadratic regression and "prcomp" for the principal components 
It calculates a linear regression model between all the columns of "ymat" (separately) and the PC's of "xmat" and their square.
}
\value{
output list contains: 
  rmse, r2, calculated on the calibration data; 
  clim, the estimates (with 95% confidence intreval) of the predictands used for calibration;
  fclim the estimates of the new environmental matrix; 
  if there is verification, it contains also: 
    rmsep, RE (or r2p) and CE (calculated on the independent data). 
  RE is the variance explained as compared with the calibration average and CE is the variance explained as compared with the verification average.
}
\references{ ~ ~ }
\author{ J. Guiot }
\note{ void
}
\examples{
output=recIK(ss700po,ss700cl,fospo%,p=5)
}
\keyword{ multivariate statistics} 
\keyword{ multiple regression}
\keyword{ principal components} 
\keyword{ transfer function}

