\name{splitdata}
\alias{splitdata}
\title{ Split the input data matrices into calibration and verification matrices }
\description{
  Three input matrices are necessary: assemblages, climate, coordinates. 
  The three matrices have the same number of rows and different number of columns.
  Each istep observation is taken for verification and the remaining ones are taken for calibration    
}
\usage{
output=splitdata(ass,clim,coord,istep)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{ass}{ \code{ass} is the assemblage data, i.e. one column per taxon }
  \item{clim}{ \code{arg2} is the climate data, same number of rows than ass }
  \item{coord}{ \code{coord} is the coordinate data, longitude, latitude, altitude, same number of rows than ass }
   \item{istep}{ Each \code{istep} observation is taken for verification and the remaining ones are taken for calibration  }
}
\details{
  The climate matrix is transformed into principal components and the observations are sorted according to the first PC.
  the selection of observations is based on the gradient of the first PC;
  for istep=2, 50% observations are used for calibration and verification;
  for istep=3, 66.6% obs for calib, 33.3% for verif.   
}
\value{
  output is a list with components : 
  output$assc = matrix of assemblages for calibration; 
  output$assv = matrix of assemblages for verification; 
  output$climc = matrix of climate for calibration; 
  output$climv = matrix of climate for verification;
  output$coordc = matrix of coordinates for calibration; 
  output$coordv = matrix of coordinates for verification; 
}
\references{ }
\author{ J. Guiot }
\note{ }
\seealso{ objects to See Also as \code{\link{help}} }
\examples{
output=splitdata(ss700po,ss700cl,ss700co,3)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ random, cross-validation }

